<?php

/**
 * @file
 * Gigwa user interface.
 */
  $settings = variable_get('gigwa', array());

  if (empty($settings)
      || empty($settings['url'])
      || empty($settings['banks'])) {
?>
    <p>Gigwa has not been configured for this site.</p>
<?php
    return;
  }

  drupal_add_library('system', 'ui.resizable');
  $query_parameters = drupal_get_query_parameters();
  $banks = array();
  foreach ($settings['banks'] as $bank) {
    $banks[$bank['machinename']] = $bank['name'];
  }

  $active_bank = $settings['default_bank'] ?: $settings['banks'][0]['machinename'];
  if (!empty($query_parameters['gigwa_bank'])
      && array_key_exists($query_parameters['gigwa_bank'], $banks)) {
    $active_bank = $query_parameters['gigwa_bank'];
  }

  // Get individual parameter id set in URL.
  // Ex.: ...&individualSubSet=ITC0063;ITC0310;ITC1220.
  $individual_subset = '';
  if (!empty($query_parameters['gigwa_subset'])) {
    $individual_subset = '&individualSubSet=' . $query_parameters['gigwa_subset'];
  }

  $gigwa_frame_url =
    $settings['url']
    . "?hideNavBar=true&amp;module=$active_bank$individual_subset";
?>
<a href="https://gigascience.biomedcentral.com/articles/10.1186/s13742-016-0131-8" title="Gigwa publication" target="_blank"><img src="/gigwa/images/logo.png" title="Gigwa" alt="Gigwa"/></a>
<form>
  <select id="gigwa_selector" style="display: none;">
    <?php
      foreach ($banks as $bank_machinename => $bank_name) {
        if ($active_bank == $bank_machinename) {
          $selected = ' selected="selected"';
        }
        else {
          $selected = '';
        }
        echo "    <option value=\"$bank_machinename\"$selected>$bank_name</option>\n";
      }
    ?>
  </select>
</form>
<br/>
<div id="gigwa_container">
  <iframe id="gigwa"  class="ui-widget-content" src="<?php echo $gigwa_frame_url; ?>">Your browser does not support iframes. Click on this <a src="<?php echo $gigwa_frame_url; ?>">Gigwa link</a> in order to access Gigwa in degraded mode.</iframe>
</div>
<script>
  jQuery(function() {
    var $gigwa_container = jQuery("#gigwa_container");
    var $gigwa = jQuery("#gigwa");
    jQuery("#gigwa_selector")
      .show()
      .on('change', function() {
        var module_offset = $gigwa.attr('src').indexOf('module=') + 7;
        var next_param_offset = $gigwa.attr('src').indexOf('&', module_offset);
        if (next_param_offset < 0) {
          next_param_offset = $gigwa.attr('src').length;
        }
        url = $gigwa.attr('src')
          .substr(0, module_offset)
            + jQuery("#gigwa_selector").val()
            + $gigwa.attr('src').substr(next_param_offset)
        ;
        $gigwa.attr('src', url);
      })
    ;
    $gigwa_container.resizable();
  });
</script>
